/*
 * bootstrap-modbox - Native JavaScript wrapper for simple Bootstrap 5 modals. Provides support for alert, confirm, and prompt modals, as well as advanced custom dialogs.
 * version: 1.2.0
 * author: Eric Robertson
 * license: MIT
 *
 * https://erobertson42.github.io/bootstrap-modbox/
 */

"use strict";function _slicedToArray(t,e){return _arrayWithHoles(t)||_iterableToArrayLimit(t,e)||_unsupportedIterableToArray(t,e)||_nonIterableRest()}function _nonIterableRest(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}function _iterableToArrayLimit(t,e){var a=null==t?null:"undefined"!=typeof Symbol&&t[Symbol.iterator]||t["@@iterator"];if(null!=a){var i,o,n=[],r=!0,l=!1;try{for(a=a.call(t);!(r=(i=a.next()).done)&&(n.push(i.value),!e||n.length!==e);r=!0);}catch(t){l=!0,o=t}finally{try{r||null==a.return||a.return()}finally{if(l)throw o}}return n}}function _arrayWithHoles(t){if(Array.isArray(t))return t}function _toConsumableArray(t){return _arrayWithoutHoles(t)||_iterableToArray(t)||_unsupportedIterableToArray(t)||_nonIterableSpread()}function _nonIterableSpread(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}function _unsupportedIterableToArray(t,e){if(t){if("string"==typeof t)return _arrayLikeToArray(t,e);var a=Object.prototype.toString.call(t).slice(8,-1);return"Map"===(a="Object"===a&&t.constructor?t.constructor.name:a)||"Set"===a?Array.from(t):"Arguments"===a||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(a)?_arrayLikeToArray(t,e):void 0}}function _iterableToArray(t){if("undefined"!=typeof Symbol&&null!=t[Symbol.iterator]||null!=t["@@iterator"])return Array.from(t)}function _arrayWithoutHoles(t){if(Array.isArray(t))return _arrayLikeToArray(t)}function _arrayLikeToArray(t,e){(null==e||e>t.length)&&(e=t.length);for(var a=0,i=new Array(e);a<e;a++)i[a]=t[a];return i}function ownKeys(e,t){var a,i=Object.keys(e);return Object.getOwnPropertySymbols&&(a=Object.getOwnPropertySymbols(e),t&&(a=a.filter(function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable})),i.push.apply(i,a)),i}function _objectSpread(e){for(var t=1;t<arguments.length;t++){var a=null!=arguments[t]?arguments[t]:{};t%2?ownKeys(Object(a),!0).forEach(function(t){_defineProperty(e,t,a[t])}):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(a)):ownKeys(Object(a)).forEach(function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(a,t))})}return e}function _classCallCheck(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}function _defineProperties(t,e){for(var a=0;a<e.length;a++){var i=e[a];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(t,i.key,i)}}function _createClass(t,e,a){return e&&_defineProperties(t.prototype,e),a&&_defineProperties(t,a),t}function _classPrivateMethodInitSpec(t,e){_checkPrivateRedeclaration(t,e),e.add(t)}function _classPrivateFieldInitSpec(t,e,a){_checkPrivateRedeclaration(t,e),e.set(t,a)}function _checkPrivateRedeclaration(t,e){if(e.has(t))throw new TypeError("Cannot initialize the same private elements twice on an object")}function _defineProperty(t,e,a){return e in t?Object.defineProperty(t,e,{value:a,enumerable:!0,configurable:!0,writable:!0}):t[e]=a,t}function _classStaticPrivateFieldSpecSet(t,e,a,i){return _classCheckPrivateStaticAccess(t,e),_classCheckPrivateStaticFieldDescriptor(a,"set"),_classApplyDescriptorSet(t,a,i),i}function _classStaticPrivateFieldSpecGet(t,e,a){return _classCheckPrivateStaticAccess(t,e),_classCheckPrivateStaticFieldDescriptor(a,"get"),_classApplyDescriptorGet(t,a)}function _classCheckPrivateStaticFieldDescriptor(t,e){if(void 0===t)throw new TypeError("attempted to "+e+" private static field before its declaration")}function _classPrivateMethodGet(t,e,a){if(!e.has(t))throw new TypeError("attempted to get private field on non-instance");return a}function _classPrivateFieldSet(t,e,a){return _classApplyDescriptorSet(t,_classExtractFieldDescriptor(t,e,"set"),a),a}function _classApplyDescriptorSet(t,e,a){if(e.set)e.set.call(t,a);else{if(!e.writable)throw new TypeError("attempted to set read only private field");e.value=a}}function _classPrivateFieldGet(t,e){return _classApplyDescriptorGet(t,_classExtractFieldDescriptor(t,e,"get"))}function _classExtractFieldDescriptor(t,e,a){if(!e.has(t))throw new TypeError("attempted to "+a+" private field on non-instance");return e.get(t)}function _classApplyDescriptorGet(t,e){return e.get?e.get.call(t):e.value}function _classStaticPrivateMethodGet(t,e,a){return _classCheckPrivateStaticAccess(t,e),a}function _classCheckPrivateStaticAccess(t,e){if(t!==e)throw new TypeError("Private static access of wrong provenance")}var _options=new WeakMap,_modal=new WeakMap,_modalEl=new WeakMap,_footer=new WeakMap,_buildModal=new WeakSet,_addButtons=new WeakSet,_addEvents=new WeakSet,modbox=function(){function l(){var t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{};if(_classCallCheck(this,l),_classPrivateMethodInitSpec(this,_addEvents),_classPrivateMethodInitSpec(this,_addButtons),_classPrivateMethodInitSpec(this,_buildModal),_classPrivateFieldInitSpec(this,_options,{writable:!0,value:void 0}),_classPrivateFieldInitSpec(this,_modal,{writable:!0,value:void 0}),_classPrivateFieldInitSpec(this,_modalEl,{writable:!0,value:void 0}),_classPrivateFieldInitSpec(this,_footer,{writable:!0,value:void 0}),_classPrivateFieldSet(this,_options,_objectSpread(_objectSpread({},_classStaticPrivateFieldSpecGet(l,l,_defaultOptions)),{},{id:_classStaticPrivateMethodGet(l,l,_getUID).call(l)},_classStaticPrivateMethodGet(l,l,_checkUserOptions).call(l,t))),"string"!=typeof _classPrivateFieldGet(this,_options).body||!_classPrivateFieldGet(this,_options).body.length)throw new Error('The "body" configuration option is required (string).');_classPrivateMethodGet(this,_buildModal,_buildModal2).call(this),_classPrivateFieldSet(this,_modal,new bootstrap.Modal(_classPrivateFieldGet(this,_modalEl),{backdrop:(t=_classPrivateFieldGet(this,_options)).backdrop,keyboard:t.keyboard,focus:t.focus})),_classPrivateMethodGet(this,_addEvents,_addEvents2).call(this),!0===_classPrivateFieldGet(this,_options).show&&this.show(_classPrivateFieldGet(this,_options).relatedTarget)}return _createClass(l,[{key:"options",get:function(){return _classPrivateFieldGet(this,_options)}},{key:"modal",get:function(){return _classPrivateFieldGet(this,_modal)}},{key:"modalEl",get:function(){return _classPrivateFieldGet(this,_modalEl)}},{key:"buttons",get:function(){return _toConsumableArray(_classPrivateFieldGet(this,_footer).querySelectorAll("button"))}},{key:"addButton",value:function(){var e=this,t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{},a=1<arguments.length&&void 0!==arguments[1]?arguments[1]:_classPrivateFieldGet(this,_options).swapButtonOrder;_classPrivateFieldGet(this,_footer).classList.remove("d-none");var i=a?"afterbegin":"beforeend";if("string"==typeof t&&t.length){_classPrivateFieldGet(this,_footer).insertAdjacentHTML(i,t);var o=this.buttons;return o[a?0:o.length-1]}var n=_objectSpread(_objectSpread({},_classStaticPrivateFieldSpecGet(l,l,_defaultButtonOptions)),{},{id:_classStaticPrivateMethodGet(l,l,_getUID).call(l,"modbox-btn-")},t);_classPrivateFieldGet(this,_footer).insertAdjacentHTML(i,'\n\t\t\t<button\n\t\t\t\ttype="button"\n\t\t\t\tclass="btn btn-'.concat(n.outline?"outline-":"").concat(n.style," ").concat(n.class," ").concat(n.size?"btn-".concat(n.size):"",'"\n\t\t\t\tid="').concat(n.id,'"\n\t\t\t\t').concat(n.title?'title="'.concat(n.title,'"'):"","\n\t\t\t\t").concat(n.close?'data-bs-dismiss="modal"':"","\n\t\t\t\t").concat(n.disabled?"disabled":"","\n\t\t\t>\n\t\t\t\t").concat(n.icon?'<i class="'.concat(n.icon,' me-2"></i>'):"").concat(n.label,"\n\t\t\t</button>\n\t\t").trim());var r=_classPrivateFieldGet(this,_footer).querySelector("#".concat(n.id));return r&&"function"==typeof n.callback&&r.addEventListener("click",function(t){return n.callback.call(r,t,e)}),r}},{key:"addEvent",value:function(t,e){var a=this;["show","shown","hide","hidden","hidePrevented"].includes(t)&&"function"==typeof e&&_classPrivateFieldGet(this,_modalEl).addEventListener("".concat(t,".bs.modal"),function(t){return e.call(_classPrivateFieldGet(a,_modalEl),t,a)})}},{key:"destroy",value:function(){this.dispose(),_classPrivateFieldGet(this,_modalEl).remove()}},{key:"toggle",value:function(){_classPrivateFieldGet(this,_modal).toggle()}},{key:"show",value:function(){var t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:_classPrivateFieldGet(this,_options).relatedTarget;_classPrivateFieldGet(this,_modal).show(t)}},{key:"hide",value:function(){_classPrivateFieldGet(this,_modal).hide()}},{key:"handleUpdate",value:function(){_classPrivateFieldGet(this,_modal).handleUpdate()}},{key:"dispose",value:function(){_classPrivateFieldGet(this,_modal).dispose()}}],[{key:"defaultOptions",get:function(){return _classStaticPrivateFieldSpecGet(l,l,_defaultOptions)},set:function(t){void 0===t&&(t={}),_classStaticPrivateFieldSpecSet(l,l,_defaultOptions,_classStaticPrivateMethodGet(l,l,_deepMerge).call(l,_classStaticPrivateFieldSpecGet(l,l,_defaultOptions),t))}},{key:"defaultButtonOptions",get:function(){return _classStaticPrivateFieldSpecGet(l,l,_defaultButtonOptions)},set:function(t){void 0===t&&(t={}),_classStaticPrivateFieldSpecSet(l,l,_defaultButtonOptions,_objectSpread(_objectSpread({},_classStaticPrivateFieldSpecGet(l,l,_defaultButtonOptions)),t))}},{key:"container",get:function(){var t,e=document.querySelector("#modbox-container");return e||((t=document.createElement("div")).id="modbox-container",e=document.body.appendChild(t)),e}},{key:"alert",value:function(){var t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{},e={title:"Alert",closeButton:_classStaticPrivateFieldSpecGet(l,l,_defaultOptions).closeButton},t=_classStaticPrivateMethodGet(l,l,_deepMerge).call(l,e,_classStaticPrivateMethodGet(l,l,_checkUserOptions).call(l,t));return _classStaticPrivateMethodGet(l,l,_buildPromiseModal).call(l,t)}},{key:"info",value:function(){var t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{};return l.alert(_objectSpread({style:"info",title:"Information"},_classStaticPrivateMethodGet(l,l,_checkUserOptions).call(l,t)))}},{key:"success",value:function(){var t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{};return l.alert(_objectSpread({style:"success",title:"Success"},_classStaticPrivateMethodGet(l,l,_checkUserOptions).call(l,t)))}},{key:"danger",value:function(){var t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{};return l.alert(_objectSpread({style:"danger",title:"Error"},_classStaticPrivateMethodGet(l,l,_checkUserOptions).call(l,t)))}},{key:"error",value:function(){return l.danger(0<arguments.length&&void 0!==arguments[0]?arguments[0]:{})}},{key:"confirm",value:function(){var t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{},e={title:"Confirm",okButton:_classStaticPrivateFieldSpecGet(l,l,_defaultOptions).okButton,closeButton:_classStaticPrivateFieldSpecGet(l,l,_defaultOptions).closeButton},t=_classStaticPrivateMethodGet(l,l,_deepMerge).call(l,e,_classStaticPrivateMethodGet(l,l,_checkUserOptions).call(l,t));return _classStaticPrivateMethodGet(l,l,_buildPromiseModal).call(l,t,"confirm")}},{key:"prompt",value:function(){var t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{},e={title:"Prompt",input:_objectSpread(_objectSpread({},_classStaticPrivateFieldSpecGet(l,l,_defaultOptions).input),{},{id:_classStaticPrivateMethodGet(l,l,_getUID).call(l,"modbox-input-")}),okButton:_classStaticPrivateFieldSpecGet(l,l,_defaultOptions).okButton,closeButton:_classStaticPrivateFieldSpecGet(l,l,_defaultOptions).closeButton},e=_classStaticPrivateMethodGet(l,l,_deepMerge).call(l,e,_classStaticPrivateMethodGet(l,l,_checkUserOptions).call(l,t));return"regexp"===_classStaticPrivateMethodGet(l,l,_typeof).call(l,null===(t=e.input)||void 0===t?void 0:t.pattern)&&(e.input.pattern=e.input.pattern.source),e.body="\n\t\t\t".concat(e.body?"<p>".concat(e.body,"</p>"):"","\n\t\t\t").concat("string"==typeof e.input?e.input:'<input\n\t\t\t\t\ttype="'.concat(e.input.type,'"\n\t\t\t\t\tclass="form-control ').concat(e.input.class,'"\n\t\t\t\t\tid="').concat(e.input.id,'"\n\t\t\t\t\tvalue="').concat(e.input.value,'"\n\t\t\t\t\t').concat(e.input.title?'title="'.concat(e.input.title,'"'):"","\n\t\t\t\t\t").concat(e.input.placeholder?'placeholder="'.concat(e.input.placeholder,'"'):"","\n\t\t\t\t\t").concat(e.input.autocomplete?'autocomplete="'.concat(e.input.autocomplete,'"'):"","\n\t\t\t\t\t").concat("number"==typeof e.input.minlength?'minlength="'.concat(e.input.minlength,'"'):"","\n\t\t\t\t\t").concat("number"==typeof e.input.maxlength?'maxlength="'.concat(e.input.maxlength,'"'):"","\n\t\t\t\t\t").concat("string"==typeof e.input.pattern&&e.input.pattern.length?'pattern="'.concat(e.input.pattern,'"'):"","\n\t\t\t\t\t").concat(e.input.required?"required":"","\n\t\t\t\t>"),"\n\t\t").trim(),_classStaticPrivateMethodGet(l,l,_buildPromiseModal).call(l,e,"prompt")}},{key:"getInstance",value:function(t){return bootstrap.Modal.getInstance(t)}},{key:"getOrCreateInstance",value:function(t){return bootstrap.Modal.getOrCreateInstance(t)}}]),l}();function _getUID(){return(0<arguments.length&&void 0!==arguments[0]?arguments[0]:"modbox-")+Math.floor(1e6*Math.random())}function _typeof(t){return"object"==typeof t?Object.prototype.toString.call(t).slice(8,-1).toLowerCase():typeof t}function _deepMerge(i,o){var n=_objectSpread(_objectSpread({},i),o);return Object.keys(n).forEach(function(t){var e=i[t],a=o[t];"object"===_classStaticPrivateMethodGet(modbox,modbox,_typeof).call(modbox,e)&&"object"===_classStaticPrivateMethodGet(modbox,modbox,_typeof).call(modbox,a)&&(n[t]=_classStaticPrivateMethodGet(modbox,modbox,_deepMerge).call(modbox,e,a))}),n}function _checkUserOptions(t){return"string"==typeof t?{body:t}:t}function _buildPromiseModal(){var l=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{},s=1<arguments.length&&void 0!==arguments[1]?arguments[1]:"alert",l=_objectSpread(_objectSpread({},l),{},{destroyOnClose:!0,defaultButton:!1,buttons:[]});return new Promise(function(e,t){var a,i,o=new modbox(l),n=[l.closeButton];["confirm","prompt"].includes(s)&&(a=function(){return e()},"prompt"===s&&"object"===_classStaticPrivateMethodGet(modbox,modbox,_typeof).call(modbox,l.input)&&((!(i=!1)===l.input.required||"number"==typeof l.input.minlength||"string"==typeof l.input.pattern&&l.input.pattern.length)&&(l.okButton.close=!1,i=!0),a=function(){var t=o.modalEl.querySelector("#".concat(l.input.id));!0===i&&!t.reportValidity()||(e(t.value),o.hide())}),n.unshift(_objectSpread(_objectSpread({},l.okButton),{},{callback:function(t,e){"function"==typeof l.okButton.callback&&l.okButton.callback.call(this,t,e),a()}})));var n=_slicedToArray(n.map(function(t){return o.addButton(t)}),2),r=n[0];n[1];"prompt"===s&&"object"===_classStaticPrivateMethodGet(modbox,modbox,_typeof).call(modbox,l.input)&&o.modalEl.querySelector("#".concat(l.input.id)).addEventListener("keyup",function(t){"Enter"===t.key&&r.click()}),o.addEvent("hide",function(){"alert"===s?e():["confirm","prompt"].includes(s)&&document.activeElement!==r&&t()}),o.show()})}function _buildModal2(){var t=["primary","secondary","success","danger","dark","body"].includes(_classPrivateFieldGet(this,_options).style),e=_classPrivateFieldGet(this,_options).titleStyle||(t?"white":"dark"),a="btn-close ".concat(t?"btn-close-white":""),t="";_classPrivateFieldGet(this,_options).title&&(t='\n\t\t\t\t<div class="modal-header '.concat(_classPrivateFieldGet(this,_options).style?"bg-".concat(_classPrivateFieldGet(this,_options).style):"",'">\n\t\t\t\t\t<h5 class="modal-title text-').concat(e,'">\n\t\t\t\t\t\t').concat(_classPrivateFieldGet(this,_options).icon?'<i class="'.concat(_classPrivateFieldGet(this,_options).icon,' me-3"></i>'):"",'\n\t\t\t\t\t\t<span id="').concat(_classPrivateFieldGet(this,_options).id,'-title">').concat(_classPrivateFieldGet(this,_options).title,'</span>\n\t\t\t\t\t</h5>\n\t\t\t\t\t<button type="button" class="').concat(a,'" data-bs-dismiss="modal" aria-label="Close"></button>\n\t\t\t\t</div>\n\t\t\t').trim()),modbox.container.insertAdjacentHTML("beforeend",'\n\t\t\t<div class="modal '.concat(_classPrivateFieldGet(this,_options).fade?"fade":"",'" id="').concat(_classPrivateFieldGet(this,_options).id,'" tabindex="-1" aria-labelledby="').concat(_classPrivateFieldGet(this,_options).id,'-title" aria-hidden="true">\n\t\t\t\t<div class="modal-dialog ').concat(_classPrivateFieldGet(this,_options).scrollable?"modal-dialog-scrollable":""," ").concat(_classPrivateFieldGet(this,_options).center?"modal-dialog-centered":""," ").concat(_classPrivateFieldGet(this,_options).size?"modal-".concat(_classPrivateFieldGet(this,_options).size):"",'">\n\t\t\t\t\t<div class="modal-content">\n\t\t\t\t\t\t').concat(t,'\n\t\t\t\t\t\t<div class="modal-body">\n\t\t\t\t\t\t\t').concat(_classPrivateFieldGet(this,_options).body,'\n\t\t\t\t\t\t</div>\n\t\t\t\t\t\t<div class="modal-footer ').concat(_classPrivateFieldGet(this,_options).justifyButtons?"d-flex justify-content-".concat(_classPrivateFieldGet(this,_options).justifyButtons):"",'"></div>\n\t\t\t\t\t</div>\n\t\t\t\t</div>\n\t\t\t</div>\n\t\t').trim()),_classPrivateFieldSet(this,_modalEl,modbox.container.querySelector("#".concat(_classPrivateFieldGet(this,_options).id))),_classPrivateFieldSet(this,_footer,_classPrivateFieldGet(this,_modalEl).querySelector(".modal-footer")),_classPrivateMethodGet(this,_addButtons,_addButtons2).call(this)}function _addButtons2(){var e=this;Array.isArray(_classPrivateFieldGet(this,_options).buttons)||(_classPrivateFieldGet(this,_options).buttons=[]),0===_classPrivateFieldGet(this,_options).buttons.length&&!0===_classPrivateFieldGet(this,_options).defaultButton?_classPrivateFieldGet(this,_options).buttons=[_classStaticPrivateFieldSpecGet(modbox,modbox,_defaultButtonOptions)]:_classPrivateFieldGet(this,_footer).classList.add("d-none"),_classPrivateFieldGet(this,_options).buttons.forEach(function(t){return e.addButton(t)})}function _addEvents2(){var a=this;Object.entries(_classPrivateFieldGet(this,_options).events).forEach(function(t){var e=_slicedToArray(t,2),t=e[0],e=e[1];a.addEvent(t,e)}),!0===_classPrivateFieldGet(this,_options).destroyOnClose&&this.addEvent("hidden",function(){return a.destroy()})}_defineProperty(modbox,"version","1.2.0");var _defaultOptions={writable:!0,value:_objectSpread(_objectSpread({},bootstrap.Modal.Default),{},{icon:null,style:"white",titleStyle:null,title:"Information",body:"",size:null,center:!1,fade:!0,show:!1,relatedTarget:void 0,scrollable:!0,destroyOnClose:!1,defaultButton:!0,swapButtonOrder:!1,justifyButtons:null,events:{},buttons:[],okButton:{label:"OK",style:"primary"},closeButton:{label:"Cancel",style:"secondary"},input:{type:"text",class:"",value:"",title:null,placeholder:null,autocomplete:"off",minlength:null,maxlength:null,pattern:null,required:!1}})},_defaultButtonOptions={writable:!0,value:{label:"Close",style:"secondary",class:"",outline:!1,size:null,icon:null,title:null,disabled:!1,close:!0,callback:null}};
//# sourceMappingURL=bootstrap-modbox.compat.min.js.map